<script setup lang="ts">
import type { BaseCard } from '@/types/base';
import {
  CaseStudyAlt,
  Principles,
  Roles,
  Verification,
  ChevronLgRight,
  LockClose,
  Devsecops,
  Increase,
  ShieldCheckLargeLight,
  CogCode,
  ContinuousDelivery,
  ContinuousDeliveryAlt,
  ClipboardCheck,
  PiggyBankAlt,
  Visibility,
  Code,
  SpeedGauge,
  Build,
} from 'slippers-ui/icons';

const icons = {
  CaseStudyAlt,
  Principles,
  Roles,
  Verification,
  ChevronLgRight,
  LockClose,
  Devsecops,
  Increase,
  ShieldCheckLargeLight,
  CogCode,
  ContinuousDelivery,
  ContinuousDeliveryAlt,
  ClipboardCheck,
  PiggyBankAlt,
  Visibility,
  Code,
  SpeedGauge,
  Build,
};

interface CardGridProps {
  title?: string;
  subtitle?: string;
  description?: string;
  cards: Array<BaseCard>;
  config?: {
    theme: string;
    columns: number;
    icon?: string;
    shortTitle?: boolean;
  };
}

const props = withDefaults(defineProps<CardGridProps>(), {
  config: () => ({
    columns: 4,
  }),
});

const colSize = computed(() => {
  return 12 / props.config.columns;
});
</script>

<template>
  <section class="slp-pt-md-96" :class="[`theme--${config?.theme}`]">
    <SlpContainer>
      <SlpTypography
        variant="heading2-bold"
        tag="h2"
        class="slp-mb-24"
        :class="{ 'card-grid-title--short': config.shortTitle }"
      >
        {{ title }}
      </SlpTypography>
      <SlpTypography v-if="subtitle" variant="heading4" tag="h3" class="slp-pb-16 card-grid-subtitle">
        {{ subtitle }}
      </SlpTypography>
      <SlpTypography variant="body2" tag="div" class="slp-pb-16">
        {{ description }}
      </SlpTypography>
      <SlpRow class="card-container">
        <SlpColumn v-for="card in cards" :key="card.title" :cols="colSize">
          <component
            :is="card.button?.config?.href ? 'a' : 'div'"
            class="card"
            :href="card.button?.config?.href"
            :data-ga-name="card.button?.config?.dataGaName"
            :data-ga-location="card.button?.config?.dataGaLocation || 'body'"
          >
            <SlpIcon v-if="card.config?.icon" class="slp-mb-16" :icon="icons[card.config.icon]" size="md" />
            <img v-if="card.image" class="card__image" :src="card.image.config.src" />
            <SlpTypography tag="h5" variant="heading5-bold" class="slp-mb-24">
              {{ card.title }}
            </SlpTypography>
            <SlpTypography tag="div" variant="body2" class="slp-mt-8">
              <span v-html="$md.render(card.description)" />
            </SlpTypography>
            <div v-if="card.button" class="card-button-container">
              <SlpButton
                v-if="card.button.text"
                :class="[card.button.config?.variant === 'pill' ? 'card-button-pill' : '']"
                :variant="card.button.config?.variant ? card.button.config.variant : 'tertiary'"
                :href="card.button.config?.href"
                :data-ga-name="card.button.config?.dataGaName || card.title.toLowerCase()"
                :data-ga-location="card.button.config?.dataGaLocation || 'body'"
              >
                {{ card.button?.text }}
                <SlpIcon v-if="card.button.config?.variant === 'tertiary'" :icon="ChevronLgRight" />
              </SlpButton>
            </div>
          </component>
        </SlpColumn>
      </SlpRow>
    </SlpContainer>
  </section>
</template>

<style lang="scss" scoped>
.theme {
  &--gradient {
    background: linear-gradient(
      159.09deg,
      #f6cdbe 0.37%,
      #f8f5ff 22.79%,
      #ffffff 44.56%,
      #e2d2f1 78.43%,
      #ffd4d8 109.47%
    );
  }

  &--light {
    padding-top: 0 !important;
    color: $color-text-300;

    .card {
      background: $color-surface-800 !important;
      transition: border-radius 0.3s $interactive-ease;
      &[href] {
        &:hover {
          border-radius: 4px 4px 100px 4px;

          .card-button-pill {
            background: $color-surface-800 !important;
          }
        }
      }

      &:before {
        background: linear-gradient(90.62deg, rgba(199, 177, 254, 0.4) 0.69%, rgba(255, 212, 216, 0.4) 100%) !important;
      }

      &-button-pill {
        background-color: $color-surface-900 !important;
      }
    }
    .card-description {
      color: $color-text-200;
    }
  }

  &--purple {
    color: $color-text-300;
    position: relative;

    &:before {
      content: '';
      background: $color-surface-800 !important;
      height: 100%;
      left: -50vw;
      position: absolute;
      top: 0;
      width: 200vw;
      z-index: -1;
    }

    .card {
      background: $color-surface-50 !important;
    }
    + .theme--purple {
      padding-top: 0 !important;
    }
    .card-description {
      color: $color-text-200;
    }
  }
}

.card-grid-title--short {
  max-width: 600px;
}

.card-grid-subtitle {
  margin-top: -$spacing-24;
}

.card-container {
  padding-bottom: $spacing-96;

  [class*='slp-col-'] {
    padding-bottom: $spacing-16;
    width: 100%;

    @media (width > $breakpoint-md) {
      padding: 0 $spacing-8 $spacing-16 $spacing-8;
    }
  }

  .slp-icon {
    height: $spacing-32;
    width: $spacing-32;
  }

  .card {
    flex: 0 1 250px;
    color: inherit;
    display: flex;
    border-radius: 4px;
    flex-direction: column;
    align-items: flex-start;
    padding: $spacing-32;
    isolation: isolate;
    background: $color-surface-50;
    z-index: 1;
    position: relative;
    height: 100%;
    width: 100%;

    &__image {
      max-width: $spacing-32;
      max-height: $spacing-32;
      margin-bottom: $spacing-16;
    }

    @media (max-width: $breakpoint-md) {
      flex-grow: 1;
    }

    &-button-container {
      margin-top: auto;
      display: flex;
      flex-direction: row;
      align-items: end;

      .slp-icon {
        height: $spacing-16;
        width: $spacing-16;
      }
    }

    &-button-pill {
      margin-top: 8px;
      font-size: 12px;
      padding: $spacing-8 12px;
      text-align: start;
      color: $color-text-link-100;
      background: $color-surface-800;
      border: 1px solid $color-surface-800;
      border-radius: 25px;
      font-weight: $font-weight-bold;

      &:hover {
        background-color: rgba($color-surface-700, 0.1);
      }
    }

    &:before {
      position: absolute;
      content: '';
      top: 0;
      right: 0;
      bottom: 0;
      left: 0;
      background: linear-gradient(141.56deg, #fff 100%, #fff 100%);
      z-index: -1;
      transition: all 0.3s ease-in-out;
      opacity: 0;
      border-radius: $spacing-4;
    }

    &[href] {
      &:hover {
        .card-button-pill {
          background-color: rgba($color-surface-700, 0.1);
        }

        &:before {
          opacity: 1;
          border-radius: 4px 4px 100px 4px;
        }

        .slp-btn-tertiary {
          text-decoration-color: $color-primary-200;
          text-decoration: underline;
          .slp-icon {
            transform: translate(8px);
          }
        }
      }
    }
  }

  .description {
    font-size: $text-body-2;
    line-height: $line-height-body-2;
    font-weight: $font-weight-normal;
  }
}
</style>
